
//////////////////////////////////////////////////////////////////////////////////////////
//											//
// file:	application.c								//
// version:	5.0									//
// author:	copyright (c) 2006 by Marko Euth <linux@euth.de>, www.euth.de		//
// last change: 09.03.2006								//
// description: This is a test application that uses the functionality provided		//
//		through cracklinux. Use this on your own risk. 				//
//											//
// license:	This program is free software; you can redistribute it and/or		//
//		modify it under the terms of the GNU General Public License		//
//		as published by the Free Software Foundation; either version 2		//
//		of the License, or (at your option) any later version.			//
//											//
//		This program is distributed in the hope that it will be useful,		//
//		but WITHOUT ANY WARRANTY; without even the implied warranty of		//
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		//
//		GNU General Public License for more details.				//
//											//
//		You should have received a copy of the GNU General Public License	//
//		along with this program; if not, write to the Free Software		//
//		Foundation, Inc., 51 Franklin Street, Fifth Floor, 			//
//		Boston, MA  02110-1301, USA						//
//											//
//////////////////////////////////////////////////////////////////////////////////////////



#include <stdio.h>		// printf()
#include <unistd.h>		// sleep()
#include <asm/io.h>		// inb(), outb()

#include <libcracklinux.h>

#define BASEPORT 0x378
#define PERROR if (ret < 0) printf("ERROR: %d\n", ret)

int parameter1 = 1;
int parameter2 = 2;

// user space isr
void USER_ISR(void * ISRarg)
{
	printf("HELLO, Here's the User ISR with argument %d\n", * (int *) ISRarg);
}

void my_fflush()
{
	while ( getchar() != '\n' ) {}
}

int main()
{
	int ret;
	char ch;
	int i;


printf("cracklinux load module\n");

	// load kernel module
	ret = CrackLoad();
		PERROR;

printf("cracklinux open device file\n");

	// open device file
	ret = CrackOpen();
		PERROR;


//////////////////////////////////////////////////////////////////////////////////////////
// driver version ////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////


do { ch = getchar(); } while (ch != '\n');
printf("cracklinux get driver version\n");

	// read driver version
	printf("cracklinux: Driver Version is: %1.2f\n", CrackGetDriverVersion() );


//////////////////////////////////////////////////////////////////////////////////////////
// memory access /////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////


do { ch = getchar(); } while (ch != '\n');
printf("cracklinux memory access\n");

	printf("cracklinux read 32 Bit: 0x%8lX\n", CrackReadPhysicalMemoryDword(0x90004, &ret) );
		PERROR;

	// write memory
	ret = CrackWritePhysicalMemoryByte(0x90004, 0xCD);		// DANGEROUS !!!!!!!!
		PERROR;

	printf("cracklinux read  8 Bit: 0x%2X\n", CrackReadPhysicalMemoryByte(0x90004, &ret) );
		PERROR;
	printf("cracklinux read 32 Bit: 0x%8lX\n", CrackReadPhysicalMemoryDword(0x90004, &ret) );
		PERROR;

	// write memory
	ret = CrackWritePhysicalMemoryWord(0x90004, 0xAB12);		// DANGEROUS !!!!!!!!
		PERROR;

	printf("cracklinux read 16 Bit: 0x%4X\n", CrackReadPhysicalMemoryWord(0x90004, &ret) );
		PERROR;
	printf("cracklinux read 32 Bit: 0x%8lX\n", CrackReadPhysicalMemoryDword(0x90004, &ret) );
		PERROR;

	// write memory
	ret = CrackWritePhysicalMemoryDword(0x90004, 0x12345678);	// DANGEROUS !!!!!!!!
		PERROR;

	printf("cracklinux read 32 Bit: 0x%8lX\n", CrackReadPhysicalMemoryDword(0x90004, &ret) );
		PERROR;


//////////////////////////////////////////////////////////////////////////////////////////
// Direct Port Access ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////


do { ch = getchar(); } while (ch != '\n');
printf("cracklinux Direct Port access\n");

	// enable port access
	ret = CrackDirectPortIo(BASEPORT, 0);
		PERROR;
	ret = CrackDirectPortIo(BASEPORT+1, 0);
		PERROR;

	// read from port
	printf("cracklinux read from port: 0x%X\n", (unsigned int) inb(BASEPORT+1));

	// write to port
	outb(0x00,BASEPORT);

	// read from port
	printf("cracklinux read from port: 0x%X\n", (unsigned int) inb(BASEPORT+1));

	// write to port
	outb(0xFF,BASEPORT);

	// read from port
	printf("cracklinux read from port: 0x%X\n", (unsigned int) inb(BASEPORT+1));

	// disable port access
	ret = CrackDirectPortIo(BASEPORT, 1);
		PERROR;
	ret = CrackDirectPortIo(BASEPORT+1, 1);
		PERROR;


//////////////////////////////////////////////////////////////////////////////////////////
// Install ISR ///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////


do { ch = getchar(); } while (ch != '\n');
printf("cracklinux Install ISR\n");

	// install isr
	ret = CrackInstallInterruptCallbackRoutine(7, USER_ISR, &parameter1);
		PERROR;
//	ret = CrackInstallInterruptCallbackRoutine(1, USER_ISR, &parameter2);
//		PERROR;

	// enable interrupts
	ret = CrackWriteIoByte(BASEPORT+2, 0x10);
		PERROR;

	do {
		ch = getchar();
		my_fflush();

		if (ch == 'q'){ break; }

		// write to port
		ret = CrackWriteIoByte(BASEPORT+0, 0);
			PERROR;

		// read from port
		CrackReadIoByte(BASEPORT+1, &ret);
			PERROR;

		// write to port
		ret = CrackWriteIoByte(BASEPORT+0, 255);
			PERROR;

		// read from port
		CrackReadIoByte(BASEPORT+1, &ret);
			PERROR;

	} while (1);

	// disable interrups
	ret = CrackWriteIoByte(BASEPORT+2, 0x0);
		PERROR;

	// uninstall isr (CrackClose does the same)
//	ret = CrackRemoveInterruptCallbackRoutine(7);
//		PERROR;
//	ret = CrackRemoveInterruptCallbackRoutine(4);
//		PERROR;
	ret = CrackRemoveAllInterruptCallbackRoutines();
		PERROR;


//////////////////////////////////////////////////////////////////////////////////////////
// Set NICE level ////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////


do { ch = getchar(); } while (ch != '\n');
printf("cracklinux Set NICE level (enter new NICE level)\n");


	do {
		if( scanf("%d",&i) == 0 )
		{
			my_fflush();
			break;
		}

		printf("Try to set NICE level: %d\n",i);

		// set NICE level
		ret = CrackSetNice(i);
			PERROR;

	} while (1);


//////////////////////////////////////////////////////////////////////////////////////////


printf("cracklinux close device file\n");

	// closes device file
	ret = CrackClose();
		PERROR;

printf("cracklinux unload module\n");

	// unload kernel modul cracklinux.ko
	ret = CrackUnload();
		PERROR;

printf("cracklinux end application\n");

	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////
//// EOF /////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
