
//////////////////////////////////////////////////////////////////////////////////////////
//											//
// file:	cracklinux.c								//
// version:	0.50									//
// author:	copyright (c) 2006 by Marko Euth <linux@euth.de>, www.euth.de		//
// last change: 09.03.2006								//
// description: These are the values the functions of libcracklinux returns in case 	//
//		of an error. This file has to be included in the application when you 	//
//		want to work with this error code.					//
//											//
// license:	This program is free software; you can redistribute it and/or		//
//		modify it under the terms of the GNU General Public License		//
//		as published by the Free Software Foundation; either version 2		//
//		of the License, or (at your option) any later version.			//
//											//
//		This program is distributed in the hope that it will be useful,		//
//		but WITHOUT ANY WARRANTY; without even the implied warranty of		//
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		//
//		GNU General Public License for more details.				//
//											//
//		You should have received a copy of the GNU General Public License	//
//		along with this program; if not, write to the Free Software		//
//		Foundation, Inc., 51 Franklin Street, Fifth Floor, 			//
//		Boston, MA  02110-1301, USA						//
//											//
//////////////////////////////////////////////////////////////////////////////////////////



// CrackLoad()
// CrackUnload()
#define cERR_FORK		10		// creating child process failed (fork failed)
#define cERR_EXEC		11		// executing insmod/rmmod failed (exec failed)
#define cERR_COMMAND		12		// insmod/rmmod itself failed
#define cERR_WAIT		13		// waiting for child process faild

// CrackOpen()
#define cERR_NOMEM		20		// no memory for io bitmap available

// all other common
#define cERR_MODE		21		// the selected command is invalid
#define cERR_INVAL_POINTER	22		// data to transfer is not valid

// CrackInstallInterruptCallbackRoutine()
#define cERR_ALREADYINSTALLED	30		// there's already an isr installed by cracklinux
#define cERR_IRQ		31		// request_irq() failed
#define cERR_THREADCREATE	32		// creating a thread for isr failed

// CrackClose()
// CrackRemoveInterruptCallbackRoutine()
// CrackRemoveAllInterruptCallbackRoutines()
#define cERR_NOTINSTALLED	33		// no isr installed for this irq
#define cERR_THREADJOIN		34		// waiting for joining the user thread failed

// CrackDirectPortIo()
#define cERR_INVAL_ADDR		40		// invalid argument (address)

// CrackSetNice()
#define cERR_INVAL_NICE		51		// invalid argument (nice level)

//////////////////////////////////////////////////////////////////////////////////////////
//// EOF /////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
